<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <title>Two sects filter</title>
</head>

<body>

<!-- У вас есть два списка - люди, ходящие в секту Любителей собак и люди, ходящие в секту Любителей кошек.
В руки настоятелю первой секты попал список людей из второй секты, и  он подозревает, что часть его людей ходят
и к Любителям кошек, потому что не определись, кого они любят больше. Поэтому он хочет исключить их из своей секты.
Для этого ему нужно составить новый список, куда будут входить только те люди из его секты, которые не упоминаются в
списке членов второй. Задача: напишите функцию arrayFilter, которая принимает в себя два массива и возвращает новый
массив, в который входят ТОЛЬКО те элементы из первого массива, которых нет во втором   -->

<script>
    let dogsFavor = [{
        name: "Мария",
        lastName: "Салтыкова",
        age: 25
    }, {
        name: "Осана",
        lastName: "Меньшинова",
        age: 20
    }, {
        name: "Андрей",
        lastName: "Первозваный",
        age: 100
    }, {
        name: "Василий",
        lastName: "Гофман",
        age: 40
    }, {
        name: "Поручик",
        lastName: "Ржевский",
        age: "вечно молодой"
    }];

    let catsFavor = [{
        name: "Мария",
        lastName: "Розгозина",
        age: 22
    }, {
        name: "Осана",
        lastName: "Меньшинова",
        age: 20
    }, {
        name: "Андрей",
        lastName: "Первозваный",
        age: 100
    }, {
        name: "Алексей",
        lastName: "Гофман",
        age: 40
    }, {
        name: "Капитан",
        lastName: "Очевидность",
        age: "вечно молодой"
    }];

    /*
    В итоге у вас должно получится:
    const newDogsFavor = arrayFilter(dogsFavor, catsFavor);
    в результате newDogsFavor = [{
        name: "Мария",
        lastName: "Салтыкова",
        age: 25
    }, {
        name: "Василий",
        lastName: "Гофман",
        age: 40
    }, {
        name: "Поручик",
        lastName: "Ржевский",
        age: "вечно молодой"
    }];
    */

    arrayFilter = (arrayDogs, arrayCats) => arrayDogs.filter(i => !arrayCats.some(x => x.name === i.name && x.lastName === i.lastName));

    const newDogsFavor = arrayFilter(dogsFavor, catsFavor);

    console.log("New Dogs Favor List", newDogsFavor);

</script>

</body>

</html>